#include <hmg.ch>

Function Main
   local mrow := 10
   private bcr, bcg, bcb, fcr, fcg, fcy
   
   bcr := bcg := bcb := 255
   fcr := fcg := fcb := 0
   
   readini()
   
   define window winmain at 0, 0 width 340 height 320 title "Color Change Test" main backcolor {bcr, bcg, bcb}
   
      define label label1
         row mrow
         col 0
         value "Change Color:"
         fontbold .t.
         backcolor {bcr, bcg, bcb}
         fontcolor {fcr, fcg, fcb}
      end label
      
      mrow += 30
      define editbox edit1
         row mrow
         col 10
         width 300
         height 150
         fontcolor {fcr, fcg, fcb}
         backcolor {bcr, bcg, bcb}
         fontbold := .t.
         value "This is a color changing test!"
      end editbox
      mrow += 160

      define button backcolor
         row mrow
         col 10
         caption "Back Color"
         action {|| getbackcolor()}
      end button
      
      define button forecolor
         row mrow
         col 120
         caption "Fore Color"
         action {|| getforecolor()}
      end button
      
      mrow += 30
      
      define button save
         row mrow
         col 10
         caption "Save"
         action {|| saveini(), winmain.release()}
      end button
      
      define button cancel
         row mrow
         col 120
         caption "Cancel"
         action {|| winmain.release()}
      end button                      

   end window
   
   winmain.Center
   winmain.Activate

Return


//---------------------------- getbackcolor()
function getbackcolor()
   local acol := getcolor({bcr, bcg, bcb})
   bcr := acol[1]
   bcg := acol[2]
   bcb := acol[3]
   changecolor()
   return nil


//---------------------------- getforecolor()
function getforecolor()
   local acol := getcolor({fcr, fcg, fcb})
   fcr := acol[1]
   fcg := acol[2]
   fcb := acol[3]
   changecolor()
   return nil

//---------------------------- changecolor()
function changecolor()
   winmain.label1.backcolor := {bcr, bcg, bcb}
   winmain.label1.fontcolor := {fcr, fcg, fcb}
   winmain.edit1.backcolor := {bcr, bcg, bcb}
   winmain.edit1.fontcolor := {fcr, fcg, fcb}
   return nil
   
   
//------------------- SaveIni   
function SaveIni()
   local mInifile := "main.ini"
	BEGIN INI FILE (mInifile)
		SET SECTION "BackColor"   ENTRY "Red"      To bcr
		SET SECTION "BackColor"   ENTRY "Green"    To bcg
		SET SECTION "BackColor"   ENTRY "Blue"     To bcb
		SET SECTION "ForeColor"   ENTRY "Red"      To fcr
		SET SECTION "ForeColor"   ENTRY "Green"    To fcg
		SET SECTION "ForeColor"   ENTRY "Blue"     To fcb
   END INI
   return nil				
   

//------------------- ReadIni
function ReadIni()
   local mInifile := "main.ini"

	If ! File(mInifile)
	  SaveIni()
	EndIf
	
	BEGIN INI FILE (mInifile)
	   GET bcr SECTION "BackColor" ENTRY "Red"
	   GET bcg SECTION "BackColor" ENTRY "Green"
	   GET bcb SECTION "BackColor" ENTRY "Blue"
	   GET fcr SECTION "ForeColor" ENTRY "Red"
	   GET fcg SECTION "ForeColor" ENTRY "Green"
	   GET fcb SECTION "ForeColor" ENTRY "Blue"
	END INI
	
	return nil      	   